docker-mailserver/test/test_helper/common.bash

194 lines
6.7 KiB
Bash
Raw Normal View History

#! /bin/bash
load 'test_helper/bats-support/load'
load 'test_helper/bats-assert/load'
Final Migration Step (#6) * first migration steps * altered issue templates * altered README * removed .travis.yml * adjusting registry & repository, Dockerfile and compose.env * Close stale issues automatically * Integrated CI with Github Actions (#3) * feat: integrated ci with github actions * fix: use secrets for docker org and update image * docs: clarify why we use -t if no tty exists * fix: correct remaining references to old repo chore: prettier automatically updated markdown as well * fix: hardcode docker org * change testing image to just testing * ci: add armv7 as a supported platform * finished migration steps * corrected linting in build-push action * corrected linting in build-push action (2) * minor preps for PR * correcting push on pull request and minor details * adjusted workflows to adhere closer to @wernerfred's diagram * minor patches * adjusting Dockerfile's installation of base packages * adjusting schedule for stale issue action * reverting license text * improving CONTRIBUTING.md PR text * Update CONTRIBUTING.md * a bigger patch at the end * moved all scripts into one directory under target/scripts/ * moved the quota-warning.sh script into target/scripts/ and removed empty directory /target/dovecot/scripts * minor fixes here and there * adjusted workflows for use a fully qualified name (i.e. docker.io/...) * improved on the Dockerfile layer count * corrected local tests - now they (actually) work (fine)! * corrected start-mailserver.sh to make use of defaults consistently * removed very old, deprecated variables (actually only one) * various smaller improvements in the end * last commit before merging #6 * rearranging variables to use alphabetic order Co-authored-by: casperklein <casperklein@users.noreply.github.com> Co-authored-by: Nick Pappas <radicand@users.noreply.github.com> Co-authored-by: William Desportes <williamdes@wdes.fr>
2021-01-16 10:16:05 +01:00
NAME=${NAME:-'docker.io/mailserver/testing:latest'}
# default timeout is 120 seconds
TEST_TIMEOUT_IN_SECONDS=${TEST_TIMEOUT_IN_SECONDS-120}
NUMBER_OF_LOG_LINES=${NUMBER_OF_LOG_LINES-10}
2020-10-18 02:08:11 +02:00
# @param ${1} timeout
# @param --fatal-test <command eval string> additional test whose failure aborts immediately
# @param ... test to run
function repeat_until_success_or_timeout {
2020-10-18 15:44:01 +02:00
local FATAL_FAILURE_TEST_COMMAND
2020-10-18 02:08:11 +02:00
if [[ "${1}" == "--fatal-test" ]]; then
2020-10-18 15:44:01 +02:00
FATAL_FAILURE_TEST_COMMAND="${2}"
shift 2
fi
2020-10-18 02:08:11 +02:00
if ! [[ "${1}" =~ ^[0-9]+$ ]]; then
echo "First parameter for timeout must be an integer, recieved \"${1}\""
return 1
fi
2020-10-18 02:08:11 +02:00
local TIMEOUT=${1}
local STARTTIME=${SECONDS}
shift 1
2020-10-18 02:08:11 +02:00
until "${@}"
do
2020-10-19 14:10:32 +02:00
if [[ -n ${FATAL_FAILURE_TEST_COMMAND} ]] && ! eval "${FATAL_FAILURE_TEST_COMMAND}"; then
2020-10-18 15:44:01 +02:00
echo "\`${FATAL_FAILURE_TEST_COMMAND}\` failed, early aborting repeat_until_success of \`${*}\`" >&2
2020-10-18 03:11:10 +02:00
return 1
fi
2020-10-18 03:11:10 +02:00
sleep 1
2020-10-18 02:08:11 +02:00
if [[ $(( SECONDS - STARTTIME )) -gt ${TIMEOUT} ]]; then
echo "Timed out on command: ${*}" >&2
return 1
fi
done
}
# like repeat_until_success_or_timeout but with wrapping the command to run into `run` for later bats consumption
2020-10-18 02:08:11 +02:00
# @param ${1} timeout
# @param ... test command to run
function run_until_success_or_timeout {
2020-10-19 14:10:32 +02:00
if ! [[ ${1} =~ ^[0-9]+$ ]]; then
2020-10-18 02:08:11 +02:00
echo "First parameter for timeout must be an integer, recieved \"${1}\""
return 1
fi
2020-10-18 02:08:11 +02:00
local TIMEOUT=${1}
local STARTTIME=${SECONDS}
shift 1
2020-10-19 14:10:32 +02:00
until run "${@}" && [[ $status -eq 0 ]]
do
sleep 1
2020-10-18 03:11:10 +02:00
if (( SECONDS - STARTTIME > TIMEOUT )); then
2020-10-18 02:08:11 +02:00
echo "Timed out on command: ${*}" >&2
return 1
fi
done
}
2020-10-18 02:08:11 +02:00
# @param ${1} timeout
# @param ${2} container name
# @param ... test command for container
function repeat_in_container_until_success_or_timeout() {
2020-10-18 02:08:11 +02:00
local TIMEOUT="${1}"
local CONTAINER_NAME="${2}"
shift 2
2020-10-18 02:08:11 +02:00
repeat_until_success_or_timeout --fatal-test "container_is_running ${CONTAINER_NAME}" "${TIMEOUT}" docker exec "${CONTAINER_NAME}" "${@}"
}
function container_is_running() {
2020-10-18 02:08:11 +02:00
[[ "$(docker inspect -f '{{.State.Running}}' "${1}")" == "true" ]]
}
2020-10-18 02:08:11 +02:00
# @param ${1} port
# @param ${2} container name
function wait_for_tcp_port_in_container() {
2020-10-19 14:10:32 +02:00
repeat_until_success_or_timeout --fatal-test "container_is_running ${2}" "${TEST_TIMEOUT_IN_SECONDS}" docker exec "${2}" /bin/sh -c "nc -z 0.0.0.0 ${1}"
}
2020-10-18 02:08:11 +02:00
# @param ${1} name of the postfix container
function wait_for_smtp_port_in_container() {
2020-10-18 02:08:11 +02:00
wait_for_tcp_port_in_container 25 "${1}"
}
2020-10-18 02:08:11 +02:00
# @param ${1} name of the postfix container
function wait_for_amavis_port_in_container() {
2020-10-18 02:08:11 +02:00
wait_for_tcp_port_in_container 10024 "${1}"
}
2020-10-18 02:08:11 +02:00
# @param ${1} name of the postfix container
function wait_for_finished_setup_in_container() {
2020-10-18 15:44:01 +02:00
local STATUS=0
repeat_until_success_or_timeout --fatal-test "container_is_running ${1}" "${TEST_TIMEOUT_IN_SECONDS}" sh -c "docker logs ${1} | grep 'is up and running'" || STATUS=1
if [[ ${STATUS} -eq 1 ]]; then
2020-10-18 02:08:11 +02:00
echo "Last ${NUMBER_OF_LOG_LINES} lines of container \`${1}\`'s log"
docker logs "${1}" | tail -n "${NUMBER_OF_LOG_LINES}"
fi
2020-10-18 15:44:01 +02:00
return ${STATUS}
}
2020-10-18 02:08:11 +02:00
SETUP_FILE_MARKER="${BATS_TMPDIR}/$(basename "${BATS_TEST_FILENAME}").setup_file"
function native_setup_teardown_file_support() {
2020-10-18 02:08:11 +02:00
local VERSION_REGEX='([0-9]+)\.([0-9]+)\.([0-9]+)'
# bats versions that support setup_file out of the box don't need this
2020-10-18 02:08:11 +02:00
if [[ "${BATS_VERSION}" =~ ${VERSION_REGEX} ]]; then
numeric_version=$(( (BASH_REMATCH[1] * 100 + BASH_REMATCH[2]) * 100 + BASH_REMATCH[3] ))
2020-10-18 02:08:11 +02:00
if [[ ${numeric_version} -ge 10201 ]]; then
if [ "${BATS_TEST_NAME}" == 'test_first' ]; then
skip 'This version natively supports setup/teardown_file'
fi
return 0
fi
fi
return 1
}
# use in setup() in conjunction with a `@test "first" {}` to trigger setup_file reliably
function run_setup_file_if_necessary() {
native_setup_teardown_file_support && return 0
2020-10-18 02:08:11 +02:00
if [ "${BATS_TEST_NAME}" == 'test_first' ]; then
2019-09-12 00:37:34 +02:00
# prevent old markers from marking success or get an error if we cannot remove due to permissions
2020-10-18 02:08:11 +02:00
rm -f "${SETUP_FILE_MARKER}"
2019-09-12 00:37:34 +02:00
setup_file
2019-09-12 00:37:34 +02:00
2020-10-18 02:08:11 +02:00
touch "${SETUP_FILE_MARKER}"
else
2020-10-18 02:08:11 +02:00
if [ ! -f "${SETUP_FILE_MARKER}" ]; then
skip "setup_file failed"
return 1
fi
fi
}
# use in teardown() in conjunction with a `@test "last" {}` to trigger teardown_file reliably
function run_teardown_file_if_necessary() {
native_setup_teardown_file_support && return 0
2020-10-18 02:08:11 +02:00
if [ "${BATS_TEST_NAME}" == 'test_last' ]; then
2019-09-12 00:37:34 +02:00
# cleanup setup file marker
2020-10-18 02:08:11 +02:00
rm -f "${SETUP_FILE_MARKER}"
teardown_file
fi
}
# get the private config path for the given container or test file, if no container name was given
function private_config_path() {
2020-10-18 02:08:11 +02:00
echo "${PWD}/test/duplicate_configs/${1:-$(basename "${BATS_TEST_FILENAME}")}"
}
2020-10-18 02:08:11 +02:00
# @param ${1} relative source in test/config folder
# @param ${2} (optional) container name, defaults to ${BATS_TEST_FILENAME}
# @return path to the folder where the config is duplicated
function duplicate_config_for_container() {
2020-10-18 03:11:10 +02:00
local OUTPUT_FOLDER
OUTPUT_FOLDER="$(private_config_path "${2}")" || return $?
rm -rf "${OUTPUT_FOLDER:?}/" || return $? # cleanup
mkdir -p "${OUTPUT_FOLDER}" || return $?
cp -r "${PWD}/test/config/${1:?}/." "${OUTPUT_FOLDER}" || return $?
2020-10-18 02:08:11 +02:00
echo "${OUTPUT_FOLDER}"
2020-10-01 14:57:05 +02:00
}
function container_has_service_running() {
2020-10-18 02:08:11 +02:00
local CONTAINER_NAME="${1}"
local SERVICE_NAME="${2}"
docker exec "${CONTAINER_NAME}" /usr/bin/supervisorctl status "${SERVICE_NAME}" | grep RUNNING >/dev/null
2020-10-01 14:57:05 +02:00
}
function wait_for_service() {
2020-10-18 02:08:11 +02:00
local CONTAINER_NAME="${1}"
local SERVICE_NAME="${2}"
repeat_until_success_or_timeout --fatal-test "container_is_running ${CONTAINER_NAME}" "${TEST_TIMEOUT_IN_SECONDS}" \
2020-10-18 02:08:11 +02:00
container_has_service_running "${CONTAINER_NAME}" "${SERVICE_NAME}"
2020-10-01 14:57:05 +02:00
}
function wait_for_changes_to_be_detected_in_container() {
2020-10-18 02:08:11 +02:00
local CONTAINER_NAME="${1}"
local TIMEOUT=${TEST_TIMEOUT_IN_SECONDS}
Final Migration Step (#6) * first migration steps * altered issue templates * altered README * removed .travis.yml * adjusting registry & repository, Dockerfile and compose.env * Close stale issues automatically * Integrated CI with Github Actions (#3) * feat: integrated ci with github actions * fix: use secrets for docker org and update image * docs: clarify why we use -t if no tty exists * fix: correct remaining references to old repo chore: prettier automatically updated markdown as well * fix: hardcode docker org * change testing image to just testing * ci: add armv7 as a supported platform * finished migration steps * corrected linting in build-push action * corrected linting in build-push action (2) * minor preps for PR * correcting push on pull request and minor details * adjusted workflows to adhere closer to @wernerfred's diagram * minor patches * adjusting Dockerfile's installation of base packages * adjusting schedule for stale issue action * reverting license text * improving CONTRIBUTING.md PR text * Update CONTRIBUTING.md * a bigger patch at the end * moved all scripts into one directory under target/scripts/ * moved the quota-warning.sh script into target/scripts/ and removed empty directory /target/dovecot/scripts * minor fixes here and there * adjusted workflows for use a fully qualified name (i.e. docker.io/...) * improved on the Dockerfile layer count * corrected local tests - now they (actually) work (fine)! * corrected start-mailserver.sh to make use of defaults consistently * removed very old, deprecated variables (actually only one) * various smaller improvements in the end * last commit before merging #6 * rearranging variables to use alphabetic order Co-authored-by: casperklein <casperklein@users.noreply.github.com> Co-authored-by: Nick Pappas <radicand@users.noreply.github.com> Co-authored-by: William Desportes <williamdes@wdes.fr>
2021-01-16 10:16:05 +01:00
2020-10-19 14:10:32 +02:00
# shellcheck disable=SC2016
repeat_in_container_until_success_or_timeout "${TIMEOUT}" "${CONTAINER_NAME}" bash -c 'source /usr/local/bin/helper-functions.sh; cmp --silent -- <(_monitored_files_checksums) "${CHKSUM_FILE}" >/dev/null'
2020-10-17 23:24:23 +02:00
}
function wait_for_empty_mail_queue_in_container() {
local CONTAINER_NAME="${1}"
local TIMEOUT=${TEST_TIMEOUT_IN_SECONDS}
Final Migration Step (#6) * first migration steps * altered issue templates * altered README * removed .travis.yml * adjusting registry & repository, Dockerfile and compose.env * Close stale issues automatically * Integrated CI with Github Actions (#3) * feat: integrated ci with github actions * fix: use secrets for docker org and update image * docs: clarify why we use -t if no tty exists * fix: correct remaining references to old repo chore: prettier automatically updated markdown as well * fix: hardcode docker org * change testing image to just testing * ci: add armv7 as a supported platform * finished migration steps * corrected linting in build-push action * corrected linting in build-push action (2) * minor preps for PR * correcting push on pull request and minor details * adjusted workflows to adhere closer to @wernerfred's diagram * minor patches * adjusting Dockerfile's installation of base packages * adjusting schedule for stale issue action * reverting license text * improving CONTRIBUTING.md PR text * Update CONTRIBUTING.md * a bigger patch at the end * moved all scripts into one directory under target/scripts/ * moved the quota-warning.sh script into target/scripts/ and removed empty directory /target/dovecot/scripts * minor fixes here and there * adjusted workflows for use a fully qualified name (i.e. docker.io/...) * improved on the Dockerfile layer count * corrected local tests - now they (actually) work (fine)! * corrected start-mailserver.sh to make use of defaults consistently * removed very old, deprecated variables (actually only one) * various smaller improvements in the end * last commit before merging #6 * rearranging variables to use alphabetic order Co-authored-by: casperklein <casperklein@users.noreply.github.com> Co-authored-by: Nick Pappas <radicand@users.noreply.github.com> Co-authored-by: William Desportes <williamdes@wdes.fr>
2021-01-16 10:16:05 +01:00
# shellcheck disable=SC2016
repeat_in_container_until_success_or_timeout "${TIMEOUT}" "${CONTAINER_NAME}" bash -c '[[ $(mailq) == *"Mail queue is empty"* ]]'
}